#include "ordenacao.c"

int binary_search(Item *v, int l, int r, Item k, Compare comp)
{
    if(l > r) return -1;
    int m = (l+r)/2; //l+(r-l)/2
    
    if(comp(&k, &v[m])==0) {
        return m;
    }
    if(comp(&k, &v[m])<0) {
        return binary_search(v, l, m-1, k, comp);
    }
    return binary_search(v, m+1, r, k, comp);
}

int search(Item *v, int l, int r, Item k, Compare comp) 
{
    int j;
    for(j=l; j<=r && comp(&v[j], &k)!=0; j++);
    return j;
}
