#ifndef _ORDENACAO_H_
#define _ORDENACAO_H_
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/time.h>


/* typedef struct{
    int item1;
    int item2;
} Item; */

typedef int Item;
typedef int (*Compare)(const void *, const void *);

#define key(A) (A)
#define less(A, B) (key(A) < key(B))
#define lesseq(A, B) (key(A) <= key(B))
#define exch(A, B) { Item t=A; A=B; B=t; }
#define compexch(A, B) if(less(B, A)) exch(A, B)

long milliseconds();

void show(Item [], int, int);
int is_sorted(Item [], int, int, Compare);

int crescente(const void *, const void *);
int decrescente(const void *, const void *);

//elementares
void selection(Item [], int, int, Compare);
void bubble(Item [], int, int, Compare);
void shaker(Item [], int, int, Compare);
void insertion(Item [], int, int, Compare);
void shell(Item [], int, int, Compare);

//eficientes

#endif
